

  /**
     * 
     * websocket聊天室功能start
     * 
     **/
  var websocket
  var msgList = []        // 消息列表
  var userId = getQueryString('userId')
  var groupId = getQueryString('groupId')
  var userName = getQueryString('userName')
  var fileTypeId = 1

  var fileId;
  /**
   * 将websocket连接封装，方便调用
   * 进入页面时连接一次websocket
   */
  function connet(user, group,userN) {   
    websocket = new WebSocket('ws://192.168.2.14:8210/chatServer.ws?uid=' + user + '&groupId=' + group + '&name=' + userN)
    mountFunc()
  }
  connet(userId, groupId, userName)

  var waiting=$(".wait")
  // waiting.hide()
  // 上传文件
  function upload(file){
    console.log(file)
    if(!file){return}
    if(file.size/1024/1024>100){
      hintbox('上传文件不能超过100M！')
      return
    }
    console.log(window.URL.createObjectURL(file))
    var formdata=new FormData();
    formdata.append('file',file)
    
    waiting.show()
    $.ajax({
      url:serveUrl+'/upload.do',
      type:'post',
      data:formdata,
      dataType:"json",
      cache: false,
      /**
       *必须false才会自动加上正确的Content-Type
          */
      contentType: false,
      /**
       * processData必须false才会避开jQuery对 formdata 的默认处理
       * XMLHttpRequest会对 formdata 进行正确的处理
       */
      processData: false,
      // xhr:function(){
      //   waiting.show()
      //   var myXhr=$.ajaxSettings.xhr()
      //   // var myXhr=new XMLHttpRequest();
      //   if(myXhr.upload){
      //     // myXhr.upload.addEventListener('progress',uploadprogress,false);
      //     myXhr.upload.onprogress=function(event){
      //       console.log(event)
      //       var loaded=event.loaded
      //       var total=event.total
      //       var per=Math.floor(100*loaded/total)
      //       if(per==100){
      //         waiting.hide()
      //       }else if(isNaN(per)){
      //         waiting.hide()
      //         hintbox('文件上传失败！')
      //         return false
      //       }
      //       $(".wait p span").text(per+'%')
      //     }
      //     return myXhr
      //   }
      // },
      success:function(result){
        if(result.ret=='0'){
          waiting.hide()
          if(file.type.indexOf('image')>-1){
            fileTypeId=2
          }else if(file.type.indexOf('application')>-1||file.type.indexOf('text')>-1){
            fileTypeId=3
          }else if(file.type.indexOf('audio')>-1){
            fileTypeId=4
          }else if(file.type.indexOf('video')>-1){
            fileTypeId=5
          }else if(file.name.lastIndexOf('.rar')){
            fileTypeId=3
          }
          fileId=result.fid
          $('.chat-textarea').val(file.name)
        }
      },
      error:function(error){
        console.log(error)
      }
    })
  }

  // 监视附件上传进度  html5方法 progress 用于监视文件上传进度
  // function uploadprogress(event){
  //   console.log(event)
  //   var loaded=event.loaded
  //   var total=event.total
  //   var per=Math.floor(100*loaded/total)
  //   if(per==100){
  //     waiting.hide()
  //   }else if(isNaN(per)){
  //     waiting.hide()
  //     hintbox('文件上传失败！')
  //     return false
  //   }
  //   $(".wait p span").text(per+'%')
  // }

  // 点击图片放大
  let large=function(el){
    for(var i = 0; i < el.length; i++){
      $('.chat-content').on('dblclick',el[i],function(event){
        event = event||window.event;
        var target = document.elementFromPoint(event.clientX, event.clientY);
        showBig(target.src);
      })
    }
  }
  function showBig(src){
      popup.getElementsByTagName("img")[0].src = src;
      popup.style.display = "block";
  }
  

  // 发送消息
  $(document).on('click', '.send-btn', function () {
    if (!$('.chat-textarea').val().trim()) return
    if ($('.chat-textarea').val().trim().length > 512) {
      hintbox('输入内容不能超过512字！')
      return
    }
    var contentObj = {
      t: 2,       //1发送给个人  2发送到群  
      // f: userId,     //发送人id
      // n: userName,   //发送人名称
      // d: new Date().getTime(),         //发送时间
      r: groupId,        //t为1时是接收人id，t为2时是群id
      c: fileId ? $('.chat-textarea').val().trim()+'|'+fileId : $('.chat-textarea').val().trim(),      //发送内容
      m: fileTypeId                    //m定义选择的文件类型，1为文本、2为图片、3为文件、4为音频、5为视频、6为超链接 ... 可以后续扩展类型添加
    }
    sendMsg(contentObj)
    fileTypeId=1
    fileId=''
  })

  // 快捷键发送消息
  $('.chat-textarea').keydown(function (e) {
    if (e.ctrlKey && e.keyCode === 13) {
      $('.send-btn').click()
    }
  })

  //   // 点击展开对话框
  //   $('.mini-chat').click(function() {
  //     $(this).hide()
  //     $('.full-chat').show()
  //   })

  //   // 点击关闭对话框
  //   $('.chat-head img').click(function() {
  //       $('.mini-chat').show()
  //       $('.full-chat').hide()
  //   })

$(function(){
  // 拖拽
  $('.full-chat').Tdrag({
    scope: 'body',
    handle: '.chat-head'
  })
})
  

  // 封装发送消息
  function sendMsg(contentObj) {
    if (websocket.readyState === 1) {
      websocket.send(JSON.stringify(contentObj))
      contentObj.f=userId
      contentObj.n=userName
      contentObj.d=new Date().getTime()
      msgList.push(contentObj)
      renderPage(msgList)
      $('.chat-textarea').val('')
    } else {
      connet(userId,groupId,userName)
      websocket.onopen = function () {
        websocket.send(JSON.stringify(contentObj))
        contentObj.f=userId
        contentObj.n=userName
        contentObj.d=new Date().getTime()
        msgList.push(contentObj)
        renderPage(msgList)
        $('.chat-textarea').val('')
      }
    }
  }

  // 加载websocket生命周期钩子
  function mountFunc() {
    websocket.onopen = function () {
      console.log('WebSocket连接成功    状态码：' + websocket.readyState + '时间：' + new Date())
      hintbox('WebSocket连接成功')
    }
    websocket.onerror = function () {
      console.log('WebSocket连接发生错误    状态码：' + websocket.readyState)
      hintbox('WebSocket连接发生错误')
    }
    websocket.onclose = function () {
      console.log('WebSocket连接关闭    状态码：' + websocket.readyState + '时间：' + new Date())
      hintbox('WebSocket连接关闭')
    }
    websocket.onmessage = function () {
        // debugger
      console.log('服务端返回：' + event.data)
      if(JSON.parse(event.data).m==-3){
        hintbox("您的账号已在别处登录，您已下线")
        websocket.close()
        window.location.href="../login.html"
      }else{
        msgList.push(JSON.parse(event.data))
        renderPage(msgList)
        if (JSON.parse(event.data).t == 2 && JSON.parse(event.data).f == userId) {		// 只有收到群消息时才会有消息提醒
          document.getElementById('chatAudio').play()
        }
      }
    }
  }

  // 加载页面消息列表
  function renderPage(list) {
    $('.chat-content').empty()
    for (var i in list) {
      var char = ''
      if(list[i].m==-1){     //上线
        char = '<div class="item"><p class="time"><span style="font-weight:bold">系统消息</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><p>' + list[i].n + '已上线</p></div></div></div>'
      }else if(list[i].m==2){     //图片的时候
        char = '<div class="item' + (list[i].f == userId ? " my" : "") + '"><p class="time"><span style="margin-right: 10px;">' + list[i].n + '</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><img src="' + imageUrl+list[i].c.split('|')[1] + '" class="dedecmsok"></div></div></div>'
      }else if(list[i].m==3){    //为文件的时候是直接下载的
        char = '<div class="item' + (list[i].f == userId ? " my" : "") + '"><p class="time"><span style="margin-right: 10px;">' + list[i].n + '</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><span>'+list[i].c.split('|')[0]+'</span><span class="link-display"><a href="' + imageUrl+list[i].c.split('|')[1] + '" target="_blank"><img src="./img/file.png"></a></span></div></div></div>'
      }else if(list[i].m==4){     //音频的时候
        char = '<div class="item' + (list[i].f == userId ? " my" : "") + '"><p class="time"><span style="margin-right: 10px;">' + list[i].n + '</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><audio controls><source src="' + imageUrl+list[i].c.split('|')[1] + '" type="audio/mpeg"></audio></div></div></div>'
      }else if(list[i].m==5){     //视频的时候
        char = '<div class="item' + (list[i].f == userId ? " my" : "") + '"><p class="time"><span style="margin-right: 10px;font-weight: ' + (list[i].f == 0 ? "bold" : "normal") + '">' + list[i].n + '</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><video width="240px" height="180px" controls><source src="' + imageUrl+list[i].c.split('|')[1] + '" type="video/mp4"></video></div></div></div>'
      }else if(list[i].m==-2){           //下线的时候
        char = '<div class="item"><p class="time"><span style="font-weight:bold">系统消息</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><p>' + list[i].n + '已下线</p></div></div></div>'
      }else{           //m为1或者其他情况 纯文本的时候
        char = '<div class="item' + (list[i].f == userId ? " my" : "") + '"><p class="time"><span style="margin-right: 10px;">' + list[i].n + '</span><span>' + getMsgTime(list[i].d) + '</span></p><div class="text-div"><div class="item-text"><p>' + list[i].c + '</p></div></div></div>'
      }
      list[i].t == 3 || list[i].t == 4 ? '' : $('.chat-content').append(char)         // 进入或离开直播间不显示
    }

    var imgs=document.getElementsByClassName("dedecmsok")
    // console.log(imgs)
    large(imgs)
    // for(var i = 0; i < imgs.length; i++){
    //   imgs[i].ondblclick=function(event){
    //     event = event||window.event;
    //     var target = document.elementFromPoint(event.clientX, event.clientY);
    //     showBig(target.src);
    //   }
    // }
    // 取消全屏查看
    var popup = document.getElementById("popup")
    popup.onclick = function (){
        popup.style.display = "none";
    }

    // 滚动条在底部
    var scrollTop = $(".chat-content")[0].scrollHeight
    $(".chat-content").scrollTop(scrollTop)
  }

  // 格式化时间
  function getMsgTime(val) {
    var hour = new Date(val).getHours() < 10 ? '0' + new Date(val).getHours() : new Date(val).getHours()
    var minute = new Date(val).getMinutes() < 10 ? '0' + new Date(val).getMinutes() : new Date(val).getMinutes()
    var second = new Date(val).getSeconds() < 10 ? '0' + new Date(val).getSeconds() : new Date(val).getSeconds()
    return hour + ':' + minute + ':' + second
  }


  window.onbeforeunload = function (e) {
    websocket ? websocket.close() : ''
  }

  /**
   * websocket聊天室功能end
   */
